Bug Hunting Session
Bug 126021 - Calc - the time required to save some files (in xls or xlsx format) is up to 20x longer in 6.2.4 versus 6.1.6
Summary: Calc - the time required to save some files (in xls or xlsx format) is up to ...
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
6.2.4.2 release
Hardware: All All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:6.4.0 target:6.3.4
Keywords: filter:xls, perf, regression
Depends on:
Blocks: Save XLS
  Show dependency treegraph
 
Reported: 2019-06-20 08:49 UTC by kabilo
Modified: 2019-10-26 08:12 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
attached file Sesit20.xls (6.60 MB, application/vnd.ms-excel)
2019-06-21 08:46 UTC, kabilo
Details
perf flamegraph (118.47 KB, application/x-bzip)
2019-10-21 19:10 UTC, Julien Nabet
Details

Note You need to log in before you can comment on or make changes to this bug.
Description kabilo 2019-06-20 08:49:35 UTC
Description:
the time required to save some files (in xls or xlsx format) is up to 20x longer in 6.2.4 versus 6.1.6. The time to save these files to ods is ok in both versions LO

Actual Results:
long time to save some file

Expected Results:
speed up the time to save the file


Reproducible: Always


User Profile Reset: No



Additional Info:
Comment 1 Xisco Faulí 2019-06-20 11:39:00 UTC
Thank you for reporting the bug. Please attach a sample document, as this makes it easier for us to verify the bug. 
(Please note that the attachment will be public, remove any sensitive information before attaching it. 
See https://wiki.documentfoundation.org/QA/FAQ#How_can_I_eliminate_confidential_data_from_a_sample_document.3F for help on how to do so.)

I have set the bug's status to 'NEEDINFO'. Please change it back to 'UNCONFIRMED' once the requested document is provided.
Comment 2 kabilo 2019-06-21 08:46:03 UTC
Created attachment 152324 [details]
attached file Sesit20.xls

saving a file Sesit20.xls takes more than 4 minutes to xls. To ods format only a few seconds.
Comment 3 Roman Kuznetsov 2019-06-24 09:50:36 UTC
saving of file from attach to XLS takes 36 sec in

Version: 6.4.0.0.alpha0+ (x86)
Build ID: 99971d009e9c96d1d47aec14ecfbfeaa06dc140d
CPU threads: 4; OS: Windows 6.1; UI render: default; VCL: win; 
TinderBox: Win-x86@42, Branch:master, Time: 2019-06-18_03:59:27
Locale: ru-RU (ru_RU); UI-Language: en-US
Calc: threaded

and only 3 sec when I saved it to ODS
Comment 4 kabilo 2019-06-24 11:55:33 UTC
Saving of file from attach to XLS takes:
11 sec in 6.1.6.3 
256 sec in 6.2.5.1
29 sec in 6.3.0.0 beta 2 (performance improvements implemented: Speed-up saving files to XLS format. tdf#85470 (Noel Grandin, Collabora)
36 sec in 6.4.0.0.alpha0+ (x86) (see Comment 3 from Roman Kuznetsov)

Version 6.2.x has an extremely long time to save the file. Even after increasing performance in 6.3, saving a file is slower than in 6.1
Comment 5 Xisco Faulí 2019-10-21 12:40:51 UTC
in

Version: 6.4.0.0.alpha1+
Build ID: de4839e66d3d195315729b95cc144cdab96b6e74
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
Calc: threaded

it takes

real	0m39,758s
user	0m39,331s
sys	0m0,588s

@Julien, would you mind retrieving a perf chart ?
Comment 6 Julien Nabet 2019-10-21 12:43:21 UTC
Xisco: no pb, I'll do this after my daytime job.
Comment 7 Julien Nabet 2019-10-21 19:10:06 UTC
Created attachment 155210 [details]
perf flamegraph

On pc Debian x86-64 with master sources updated today, I could reproduce this.

Here is the Flamegraph.
Comment 8 Xisco Faulí 2019-10-21 20:06:30 UTC
@Noel, I thought you might be interested in this performance issue...
Comment 9 Commit Notification 2019-10-25 09:06:37 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/c0b8be4d7eb9fa1a0d8abfb1d27c71ac34bffd1b

tdf#126021 speed up saving xls with lots of styles

It will be available in 6.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2019-10-25 10:03:02 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "libreoffice-6-3":

https://git.libreoffice.org/core/commit/cb15e56dfd4e3443467c0b54522023bbe03505e9

tdf#126021 speed up saving xls with lots of styles

It will be available in 6.3.4.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 11 Xisco Faulí 2019-10-25 17:27:19 UTC
it takes

real	0m5,160s
user	0m5,109s
sys	0m0,310s

in

Version: 6.4.0.0.alpha1+
Build ID: c0b8be4d7eb9fa1a0d8abfb1d27c71ac34bffd1b
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
Calc: threaded

niceeee!

@Noel, thanks for fixing this issue!!
Comment 12 Cor Nouws 2019-10-26 08:12:39 UTC
I think it is fair to mark the issue as a regression.
And flowers for Kabilo, Julien, Xisco, Noël :)